#{extends 'borderNG.html' /}


#{set 'titleHead'}
&{'auction.info_tender'} ${lelang.namaPaket}
#{/set}

<ul class="breadcrumb">
    <li><a href="@{BerandaCtr.index()}">&{'auction.home'}</a></li>
    <li class="active">&{'auction.info_tender'}</li>
</ul>

#{tabmenuLelang tahapStarted/}
<div class="content">
    <div class="bs-callout bs-callout-info">
        &{'auction.browser_disarankan'}
    </div>
    <table class="table table-sm">
        <tr>
            <th width="25%" class="bg-warning">&{'auction.kode'}</th>
            <td><b>${lelang.lls_id} #{if !production} <span class="label label-info">#{if lelang.lls_sesi == 0} sesi default#{/if} #{else}
                sesi ${lelang.lls_sesi}#{/else}</span> #{/if}</b>
            </td>
        </tr>
        <tr>
            <th class="bg-warning">&{'auction.nama'}</th>
            <td>${lelang.namaPaket} #{statusTender lelang/}</td>
        </tr>
        <tr>
            <th class="bg-warning">&{'auction.metode'}</th>
            <td>${lelang.pemilihan.label}</td>
        </tr>
        <tr>
            <th class="bg-warning">&{lelang.express ? 'auction.nilai' : 'auction.nilai_terendah'}</th>
            <td>${auction?.ra_min_penawaran?.rupiah()}</td>
        </tr>
        <tr>
            <th class="bg-warning">&{'auction.waktu'}</th>
            <td id="waktu">#{if editable} ${auction.sisaWaktu()} #{/if} #{else} ${auction.getWaktu()} #{/else}</td>
        </tr>
        <tr>
            <th class="bg-warning">&{'auction.status'}</th>
            <td>${auction.status}</td>
        </tr>
        <tr>
            <td colspan="2" id="hps-content">
                <div id="alert"></div>
                <div id="tbl-rincian" style="margin:20px; margin-bottom: 50px;"></div>
                <div class="float-right">
                    <table id="rekap" class="table table-sm" style="width:300px;margin-right:170px;">
                        <tr>
                            <th style="text-align:right">&{'auction.total_nilai'}</th>
                            <th id="total_hps" style="text-align:right"></th>
                        </tr>
                    </table>
                </div>
                #{if editable}
                #{authenticityToken /}
                <button type="button" name="simpan" id="simpan" class="btn btn-success"><i class="fa fa-save"></i> &{'auction.kirim'}
                    &{'auction.penawaran'}
                </button>
                #{/if}
            </td>
        </tr>
        <tr>
            <th class="bg-warning">&{'auction.penawaran'}</th>
            <td>
                <table class="table table-sm table-bordered" id="penawaranList">
                    <thead>
                    <tr>
                        <th>Harga Penawaran</th>
                        <th>Waktu Pengiriman</th>
                        <th>Keterangan</th>
                        <th>Nama File</th>
                    </tr>
                    </thead>
                    <tbody>
                    #{list items:penawaranlist, as:'item'}
                    <tr id="${item.rad_id}">
                        <td>${item.rad_nev_harga?.rupiah()}</td>
                        <td>${item.auditupdate?.formatDateTime()}</td>
                        <td>#{if penawaranTermurah && penawaranTermurah == item.rad_id} &{'auction.penawaran_anda_terendah'} #{/if}}</td>
                        <td>#{if item.getDokumen() != null}
                            <a href="${item.downloadUrl}" data-attach-file="true">${item.getDokumen().blb_nama_file}</a>
                            #{/if}
                            #{else}&nbsp;#{/else}
                        </td>
                    </tr>
                    #{/list}
                    </tbody>
                </table>
            </td>
        </tr>
    </table>

</div>

#{set 'css_custom' }
<link href="#{assets '/handsontable/handsontable.full.min.css'/}" rel="stylesheet" type="text/css">
#{/set}

#{set 'custom_script'}
<script type="text/javascript" src="https://cdnjs.cloudflare.com/ajax/libs/event-source-polyfill/0.0.9/eventsource.min.js"></script>
<script type="text/javascript" src="#{assets '/handsontable/handsontable.full.min.js'/}"></script>
<script type="text/javascript" src="https://cdnjs.cloudflare.com/ajax/libs/PapaParse/5.1.0/papaparse.min.js"></script>
<script type="text/javascript" src="#{assets '/js/aes.js' /}"></script>
<script type="text/javascript" src="#{assets '/js/pbkdf2.js' /}"></script>
<script type="text/javascript" src="#{assets '/js/AesUtil.js' /}"></script>
<script type="text/javascript" src="https://cdnjs.cloudflare.com/ajax/libs/blueimp-file-upload/10.13.1/js/vendor/jquery.ui.widget.min.js"></script>
<script type="text/javascript" src="https://cdnjs.cloudflare.com/ajax/libs/blueimp-file-upload/10.13.1/js/jquery.iframe-transport.min.js"></script>
<script type="text/javascript" src="https://cdnjs.cloudflare.com/ajax/libs/blueimp-file-upload/10.13.1/js/jquery.fileupload.min.js"></script>
<script type="text/javascript" src="https://cdnjs.cloudflare.com/ajax/libs/blueimp-file-upload/10.13.1/js/jquery.fileupload-process.min.js"></script>
<script type="text/javascript" src="https://cdnjs.cloudflare.com/ajax/libs/blueimp-file-upload/10.13.1/js/jquery.fileupload-validate.min.js"></script>
<script type="text/javascript">
        #{if editable}
            $('#simpan').removeAttr("disabled");
            var source = new EventSource('@{lelang.AuctionSSECtr.join(lelang.lls_id)}')
            var aesUtil = new AesUtil(256, 1000);
            var file_id = undefined;
            setFileId = function(fid){
                file_id = fid;
            }
            source.onmessage = function(event) {
                var data = aesUtil.decrypt('${salt}', '${iv}', '${token}', event.data);
                var obj = $.parseJSON(data)
                if(obj.waktu) {
                    $('#waktu').html(obj.waktu)
                }
                if(obj.id) {
                    // console.log('data : '+JSON.stringify(obj.data))
                    var row = '<tr id="'+obj.id+'"><td>' + obj.penawaran + '</td><td>' + obj.waktu_pengiriman + '</td><td>' + obj.keterangan + '</td>';
                    if(obj.file_url!==''){
                      row = row + '<td><a href="'+obj.file_url+'" data-attach-file="true">'+obj.nama_file+'</a></td>';
                    } else {
                      row = row + '<td>&nbsp;</td>';
                    }
                    row = row + '</tr>';
                    var firstRow = $("#penawaranList tbody tr:first")
                    if(obj.keterangan.length > 0) { // hapus keterangan
                        firstRow.find('td:last').html("");
                    }
                    if(firstRow.attr("id") == obj.id ) {
                        firstRow.remove()
                    }
                    $('#penawaranList tbody').prepend(row)
                }
            };
            source.onopen = function(e) {
                console.log("Connection was opened")
            };

            source.onerror = function(e) {
                if (e.readyState == EventSource.CLOSED) {
                    console.log("Connection was closed")
                    $('#simpan').attr("disabled", "disabled")
                }
            };
        #{/if}
        var data = ${data?.raw()};
        var interval = 2 * 60 * 1000; // 2 menit
        var total = 0;
        var fixed = true;

        function replaceChar(str) {
            var strs = "";
            if (str != undefined)
                strs += str;

            return strs.replace(/[^a-zA-Z0-9.,!@#$%&@*()-+=/\-\s ]/g, "");
        }

        var language = {
            delimiters: {
                thousands: '.',
                decimal: ','
            },
            abbreviations: {
                thousand: 'rb',
                million: 'jt',
                billion: 'M',
                trillion: 'B'
            },
            ordinal: function (number) {
                var b = number % 10;
                return (~~(number % 100 / 10) === 1) ? 'th' : (b === 1) ? 'st' : (b === 2) ? 'nd' : (b === 3) ? 'rd' : 'th';
            },
            currency: {
                symbol: 'Rp.'
            }
        };

        // Node
        if (typeof module !== 'undefined' && module.exports) {
            module.exports = language;
        }

        // Browser
        if (typeof window !== 'undefined' && this.numeral && this.numeral.language) {
            this.numeral.language('id', language);
        }
        $("#tbl-rincian").handsontable({
            rowHeaders: true,
            dataSchema: {
                item: "",
                unit: "",
                vol: 1,
                unit2: "",
                vol2: 1,
                harga: 0,
                pajak: 10,
                total_harga: 0,
                keterangan: ""
            },
            data: data,
            #{if editable}
                contextMenu: {
                    callback: function (key, row, col, options) {
                        if (key === 'make_read_only') {
                            console.log("row : " + row);
                            console.log("col : " + col);
                        }
                    },
                    items: {
                        "row_above": {name: "Tambah Baris Diatas"},
                        "row_below": {name: "Tambah Baris Dibawah"},
                        "remove_row": {name: "Hapus Baris"},
                        "undo": {name: "Undo"},
                        "redo": {name: "Redo"}
                    }
                },
            #{/if}
            language: 'id',
            columns: [{data: 'item', width: 200, title: 'Jenis Barang/Jasa', readOnly: true},
                {data: 'unit', width: 100, title: 'Satuan', readOnly: true},
                {data: 'vol', type: 'numeric',  format: '0,0.00', width: 50, title: 'Vol', allowInvalid: false,readOnly: true },
                {data: 'harga', type: 'numeric', format: '0,0.00', width: 100, title: 'Harga', allowInvalid: false},
                {data: 'pajak', type: 'numeric', format: '0,0.00', width: 60, title: 'Pajak (%)', dataSchema: 10, allowInvalid: false, readOnly: true},
                {data: 'total_harga', type: 'numeric', format: '0,0.00', width: 100, title: 'Total', allowInvalid: false, readOnly: true},
                {data: 'keterangan', width: 100, title: 'Keterangan'}],
            cells: function (row, col, prop) {
                var cellProperties = {};
                #{if editable}
                    if (col == 5) {
                        cellProperties.readOnly = true;
                    }
                    if (data[row] && (col == 2 || col == 3 || col == 4)) {
                        var total = 0;
                        var strs = "";
                        if (data[row].vol <= 0)
                            data[row].vol = 1.0;
                        if (data[row].harga > 0)
                            total = data[row].harga;
                        if (data[row].harga == '')
                            data[row].harga = 0;
                        if (data[row].vol > 0) {
                            data[row].vol = rounded2Decimal(parseFloat(data[row].vol));
                            total = total * data[row].vol;
                        }
                        if (data[row].pajak > 0)
                            total = total + ((total * data[row].pajak) / 100);
                        else
                            data[row].pajak = 0;
                        if (total >= 0) {
                            data[row].total_harga = rounded2Decimal(total);
                        }
                    }
                    if (data[row] && (col == 1 || col == 2 || col == 6)) {
                        data[row].item = replaceChar(data[row].item);
                        data[row].unit = replaceChar(data[row].unit);
                        data[row].keterangan = replaceChar(data[row].keterangan);
                    }
                #{/if}
                #{else}
                    cellProperties.readOnly = true;
                #{/else}
                return cellProperties;
            },
            afterChange: function (change, source) {
                summary();
            },
            afterRemoveRow: function () {
                summary();
            }
        });

        function summary() {
            var data = $("#tbl-rincian").data('handsontable').getData();
            var total_hps = 0;
            var total = 0;
            for (i = 0; i < data.length; i++) {
                if (data[i].total_harga)
                    total += parseFloat(data[i].total_harga);
            }
            if (total > 0) {
                total_hps = parseFloat(total);
            }
            $("#rekap").find("#total_hps").text(toRupiah(rounded2Decimal(total_hps)));
        }
            #{if editable}
            $(document).on("click", "#simpan", function () {
                var postdata = $("#tbl-rincian").data('handsontable').getData();
                var token = $("input[name='authenticityToken']").val();
                var total = toNumber($("#rekap").find("#total_hps").text());
                var prosentase = (total/${hps})*100;
                BootstrapDialog.show({
                    title : 'Konfirmasi',
                    message : function(dialog) {
                        var $content = $('<div>Apakah Anda yakin dengan Harga Penawaran Anda: <br/><br/> <div style="text-align: center;"><h2>' + $("#rekap").find("#total_hps").text() + ' </h2></div></div>')
                        if(prosentase < 80){
                            $content.append(' <br /><div style="text-align: center;" class="alert alert-danger">Harga Penawaran Anda di bawah 80% dari Nilai HPS')

                            $content.append('<div class="alert alert-success">'+
                                    '<table>' +
                                    '<tbody>' +
                                    '<tr>' +
                                    '<th>' +
                                    '<div id="uploadDok" class="btn btn-success fileinput-button">'+
                                    '<i class="fa fa-plus-circle"></i>'+
                                    '<span> Upload</span>'+
                                    '</div>'+
                                    // '<i class="fa fa-plus-circle"></i>'+
                                    // '<span> Upload </span>'+
                                    '<input hidden name="file" type="file" id="UploadRincianHPS" accept=".xls, .xlsx" style="width:85px; color:transparent;" >'+
                                    '</th>' +
                                    '<td>' +
                                    // '<span>' +
                                    '<p id="fileNameText" style="margin-bottom: 0 !important; margin-top: 3px !important; margin-left: 3px; text-overflow: ellipsis; overflow: hidden; width: 320px; white-space: nowrap; "></p>' +
                                    // '</span>'+
                                    '<span hidden id="fileText"></span>'+
                                    '</td>' +
                                    '</tr>' +
                                    '</tbody>'+
                                    '</table>'+
                            '</div>');
                            $content.append('</div>');
                        }
                        $content.append('<div style="margin-top: 10px" class="form-check"><input class="form-check-input" type="checkbox" id="check_confirmation" value="check"> <label class="form-check-label">Saya menyadari bahwa penawaran di atas sudah sesuai dengan penawaran Saya.</label></div>');
                        $content.find('input:checkbox:first').change(function() {
                            if ($(this).is(':checked') && file_id !== undefined)
                                dialog.getButton('btn1').enable();
                            else if($(this).is(':checked'))
                                dialog.getButton('btn1').enable();
                            else
                            	dialog.getButton('btn1').disable();
                        })
                        //if($content.find('input:checkbox:first').is(':checked'))
                        return $content;
                    },
                    onshow: function(dialog) {
                        dialog.getButton('btn1').disable();
                        var a = dialog.getModalHeader();
                        a[0].getElementsByClassName('bootstrap-dialog-header')[0].style.width = "100%";
                        // console.log();
                        $(document).on('click', '#UploadRincianHPS', uploadFile );
                        $(document).on('click', '#uploadDok', function (){
                            document.getElementById('UploadRincianHPS').click()
                        } );
                    },
                    buttons: [
                        {id: 'btn1', label: 'Kirim',  title: 'Kirim Penawaran', cssClass: 'btn-success', action:function(dialog){
                            dialog.close();
                            var aesUtil = new AesUtil(256, 1000);
                            postdata = aesUtil.encrypt('${salt}', '${iv}', '${token}', JSON.stringify(postdata));
                            total = aesUtil.encrypt('${salt}', '${iv}', '${token}', total.toString());
                            $.ajax({
                                url: '@{lelang.AuctionCtr.submitPenawaran(lelang.lls_id)}',
                                data: {"data": postdata, "file_id":file_id, "total": total, "authenticityToken": token},
                                type: 'POST',
                                success: function (res) {
                                    if (res.message === 'ok'){
                                        $('#alert').html('<div class="alert alert-success" data-auto-dismiss="5000">Data berhasil tersimpan</div>');
                                        location.reload();}
                                    else if (res.message.length > 0)
                                        $('#alert').html('<div class="alert alert-danger" data-auto-dismiss="5000">' + res.message + '</div>');
                                    else
                                        $('#alert').html('<div class="alert alert-danger" data-auto-dismiss="5000">Data gagal tersimpan, mohon periksa kembali inputan Anda</div>');
                                        autoCloseAlert();
                                    },
                                error: function () {
                                    $('#alert').html('<div class="alert alert-danger" data-auto-dismiss="5000">Data gagal tersimpan karena ada kendala jaringan/server</div>');
                                    autoCloseAlert();
                                }
                            });
                        }},
                        {id: 'btn2', label: 'Batal', title: 'Batal Kirim Penawaran', action: function(dialog){ dialog.close();}, cssClass: 'btn-primary'}
                     ]
                });
            });
            var fileName = "";
            var fileTypes = "";
            var _validFileExtensions = ["application/vnd.openxmlformats-officedocument.spreadsheetml.sheet", "application/vnd.ms-excel"];
            uploadFile = function() {
//                  $('#alert-upload-infolain').html('${pesertaId}').show();
                 $('#UploadRincianHPS').fileupload({
                     url: '@{lelang.AuctionSSECtr.RaHpsExcel(lelang?.lls_id, peserta, auction)}',
                     dataType: 'json',
                     acceptFileTypes: /(\.|\/)(xls|xlsx)$/i,
                     add: function (e, data) {

                  		$.each(data.files, function (index, file) {
                  			fileName = file.name;
                  			fileTypes = file.type;
                  		})
                         // console.log(fileTypes);
                         if (fileTypes !== null) {
                             var blnValid = false;
                             for (var j = 0; j < _validFileExtensions.length; j++) {
                                 var sCurExtension = _validFileExtensions[j];
                                 if (fileTypes.toLowerCase() === sCurExtension.toLowerCase()) {
                                     blnValid = true;
                                     break;
                                 }
                             }

                             if (!blnValid) {
                                 alert("Maaf, " + fileName + " tidak diizinkan! File yang diizinkan adalah file .xls atau .xlsx.");
                                 data.abort();
                                 $('#fileText').text("");
                                 $('#fileNameText').text("");
                                 setFileId(null);
                                 return false;
                             }
                         }
  	                	var message = "Apakah Anda yakin akan umumkan '"+ fileName + "' sebagai rincian HPS?";
              			if(confirm(message) == true)
              			{
             				data.submit();
              			} else {
              				data.abort();
              			}
                     },
                     done: function (e, data) {
                        $('#fileText').text(fileName);
                        $('#fileNameText').text(fileName);
                        setFileId(data.result.file_id);
                        $('#check_confirmation').prop('checked',false);
                        dialog.getButton('btn1').disable();
                     },
                     progressall: function (e, data) {

                     }
                 }).on('fileuploadprocessalways', function (e, data) {

                 }).prop('disabled', !$.support.fileInput).parent().addClass($.support.fileInput ? undefined : 'disabled');

              }
            #{/if}
</script>
#{/set}